/*
 * midiout.c
 */

#include  <stdio.h>
#include  <stdlib.h>
#include  <string.h>
#include  <unistd.h>
#include  <fcntl.h>

#include  "contexte.h"
#include  "midi_out.h"
/* + + + + + + + + + + + + + + + + + + + + + + + + + + + + joymidi + + */

static int	fdport;
static int	midichannel;

/* + + + + + + + + + + + + + + + + + + + + + + + + + + + + joymidi + + */
/* this function is intended to open a 'raw( MIDI device */

int open_midi_out(char *mididev, int k)
{
char	chaine[1000], *cptr;
int	foo;

#if DEBUG_LEVEL
fprintf(stderr, ">>>> %s (( '%s' , %d ))\n", __func__, mididev, k);
#endif

fdport = open(mididev, O_WRONLY);
if (fdport < 0)
	{
	perror(mididev);
	exit(5);
	}
#if DEBUG_LEVEL
fprintf(stderr, "     fdport is %d\n", fdport);
#endif

get_context("midichannel", chaine);
fprintf(stderr, "[%s]\n", chaine);

midichannel = strtol(chaine, &cptr, 0);

fprintf(stderr, "midichannel is %d\n", midichannel);

return -1;
}
/* + + + + + + + + + + + + + + + + + + + + + + + + + + + + joymidi + + */
/* the purpose of this buggy func is unknow */
void test_midi_out(void)
{
int		foo, chan, note;
unsigned char 	buffer[100];

for (chan=0; chan<16; chan++)
	{
	for (note=30; note<60; note++)
		{
		buffer[0] = 0x91 + (chan);
		buffer[1] = note;
		buffer[2] = 200;
		foo = write(fdport, buffer, 3);
		fprintf(stderr, "  %d/%d   =>   %d\n", chan, note, foo);
		}
	sleep(1);
	}
}
/* + + + + + + + + + + + + + + + + + + + + + + + + + + + + joymidi + + */
int send_midi_out(unsigned char *codes, int count)
{
int	foo;

#if DEBUG_LEVEL
fprintf(stderr, ">>>> %s (( %p , %d ))\n", __func__, codes, count);
#endif

for (foo=0; foo<count; foo++)
	printf(">%02x ", codes[foo]);
puts("");

return -1;
}
/* + + + + + + + + + + + + + + + + + + + + + + + + + + + + joymidi + + */
