/*
 * jmidi.h - dwtfyw licence - tTh 2014
 */

typedef struct
	{
	int	channel;	/* MIDI channel, -1 means default */
	int	button;		/* wtf ? */
	int	note;		/* -1 means not configured */
	} TransJ2M;


#define NB_MAX_TRANS	42
#define NB_MAX_BUTTONS	42

typedef struct
	{
	char	name[T_LINE_CTX+1];
	int	type;
	int	num;
	} ButtonName;

int	load_translations(char *fname);
int	get_translation(int button);		/* XXX proto may change */
int	dump_translations(char *txt, int num);
char	*jsevent2text(int event);

int	load_buttons_names(char *fname);
int	dump_buttons_names(void);
char	*lookup_button_name(int num, int type);
int	lookup_button_number(char *name);

/* auxiliary misc functions */
int	millisleep(int ms);

